<?php
namespace App\Controller;

use Cake\Datasource\Exception\RecordNotFoundException;
use Cake\Datasource\ResultSetInterface;
use Cake\Http\Response;
use Cake\Mailer\MailerAwareTrait;
use Cake\ORM\Table;
use Cake\ORM\TableRegistry;
use Cake\Routing\Router;

/**
 * Users Controller
 *
 *
 * @method \App\Model\Entity\User[]|ResultSetInterface paginate($object = null, array $settings = [])
 * @property bool|object Authentication
 */
class UsersController extends AppController
{
    /**
     * @var Table
     */
    private $users;
    private $logins;

    public function initialize()
    {
        parent::initialize();
        // TODO: Change the autogenerated stub
        $this->Authentication->allowUnauthenticated(['login']);
        $this->loadComponent('Paginator');
    }

    /**
     * Index method
     *
     * @return void
     */
    public function index()
    {
        $config = [
            'contain' => 'login',
            'limit' => 10,
            'order' => [
                'id' => 'asc'
            ],
            'sortWhitelist' => [
                'id', 'name', 'birth', 'sex', 'username'
            ]
        ];
        $title = 'List User';
        $user = TableRegistry::getTableLocator()->get('User');
//        $user->find('all')->contain(['login']);
        $listUser = $this->paginate($user, $config); //thêm contain vào config để join
        // echo json_encode($listUser); exit();
        $urlAdd = Router::url(['controller' => 'Users', 'action' => 'add']);
        $this->set(compact('title', 'listUser', 'urlAdd'));
    }

    /** @noinspection PhpInconsistentReturnPointsInspection */
    public function login()
    {
        $config = [
            // 'contain' => 'login',
            'limit' => 10,
            'order' => [
                'id' => 'asc'
            ],
            'sortWhitelist' => [
                'id', 'name', 'birth', 'sex', 'username'
            ]
        ];
        $title = 'List User';
        $user = TableRegistry::getTableLocator()->get('User');
//        $user->find('all')->contain(['login']);
        $listUser = $this->paginate($user, $config); //thêm contain vào config để join
        echo json_encode($listUser); exit();


        // $title = 'Login';
        // if ($this->request->is('post')) {
        //     $login = $this->Auth->identify();
        //     if ($login) {
        //         if ($this->request->getData('remember_me')){
        //             $this->Cookie->write('remember_me', '1');
        //             $this->Cookie->write('User', $login);
        //         }
        //         $this->Auth->setUser($login);
        //         return $this->redirect($this->Auth->redirectUrl());
        //     }
        // }

        // $result = $this->Authentication->getResult();
        // // If the user is logged in send them away.
        // if ($result->isValid()) {
        //     $target = $this->Authentication->getLoginRedirect() ?? '/user';
        //     return $this->redirect($target);
        // }

        // if ($this->Cookie->read('remember_me')){
        //     $loginCookie = $this->Cookie->read('User');
        //     if ($loginCookie) {
        //         $this->Auth->setUser($loginCookie);
        //         $this->Flash->success('Login with cookie');
        //         return $this->redirect($this->Auth->redirectUrl());
        //     }
        // }

        // if ($this->request->is('post') && !$result->isValid()) {
        //     $this->Flash->error('Invalid username or password');
        // }
        // $this->set(compact('title'));
    }

    public function logout()
    {
        $this->Authentication->logout();
        $this->Cookie->delete('remember_me');
        $this->Cookie->delete('User');
        return $this->redirect(['controller' => 'Users', 'action' => 'login']);
    }

    /**
     * View method
     *
     * @param string|null $id User id.
     * @return void
     */
    public function view($id = null)
    {
        $user = $this->users->get($id, [
            'contain' => [],
        ]);

        $this->set('user', $user);
    }

    /**
     * Add method
     *
     * @return Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $title = 'Add User';
        $this->users = TableRegistry::getTableLocator()->get('User');
        $this->logins = TableRegistry::getTableLocator()->get('Login');
        $actionArray = [
            'url' => [
                'controller' => 'Users',
                'action' => 'add'
            ]
        ];
        $info = null;

        $idUser = $this->request->getQuery('id');
        if (!empty($idUser)){
            $info = $this->users->find('all')
                ->where(['User.id' => $idUser])
                ->contain(['login'])->toArray();
            $info = end($info);
            $title = 'Edit User';
            $actionArray = [
                'url' => [
                    'controller' => 'Users',
                    'action'    => 'edit',
                    'id'        => $idUser
                ]
            ];
        }
        if ($this->request->is(['post'])) {
            $dataSource = $this->users->getConnection();
            $dataSource->begin();

            $user = $this->users->newEntity();
            $user->name = $this->request->getData('name');
            $user->birth = $this->request->getData('birth');
            $user->sex = $this->request->getData('sex');

            if ($this->users->save($user)) {
                $login = $this->logins->newEntity();
                $login->username = $this->request->getData('username');
                $login->password = $this->request->getData('password');
                $login->user_id = $user->id;

                if ($this->logins->save($login)){
                    $this->Flash->success(__('The user and account has been saved.'));
                    $dataSource->commit();
                    return $this->redirect(['action' => 'index']);
                }
            }
            $dataSource->rollback();
            $this->Flash->error(__('The user and account could not be saved. Please, try again.'));
        }
        $this->set(compact('title', 'actionArray', 'info'));
    }

    /**
     * Edit method
     *
     * @param string|null $id User id.
     * @return Response|null Redirects on successful edit, renders view otherwise.
     * @throws RecordNotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $title = 'Edit User';
        $this->users = TableRegistry::getTableLocator()->get('User');
        $this->logins = TableRegistry::getTableLocator()->get('Login');

        $user = $this->users->get($id);
        $login = $this->logins->find()->where(['user_id' => $id])->toArray();
        $login = end($login);

        if ($this->request->is(['post'])) {
            $dataSource = $this->users->getConnection();
            $dataSource->begin();

            $user->name = $this->request->getData('name');
            $user->birth = $this->request->getData('birth');
            $user->sex = $this->request->getData('sex');

            if ($this->users->save($user)) {
                $login->username = $this->request->getData('username');
                $login->password = $this->request->getData('password');
                if ($this->logins->save($login)){
                    $this->Flash->success(__('The user and account has been updated.'));
                    $dataSource->commit();
                    return $this->redirect(['action' => 'index']);
                }
            }
            $dataSource->rollback();
            $this->Flash->error(__('The user and account could not be updated. Please, try again.'));
        }
        $this->set(compact('title', 'listUser'));
        $this->render('index');
    }

    /**
     * Delete method
     *
     * @param string|null $id User id.
     * @return Response|null Redirects to index.
     * @throws RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $this->users = TableRegistry::getTableLocator()->get('User');
        $this->logins = TableRegistry::getTableLocator()->get('Login');
        $user = $this->users->get($id);
        $login = $this->logins->find()->where(['user_id' => $id])->toArray();
        $login = end($login);

        $dataSource = $this->logins->getConnection();
        $dataSource->begin();
        if (empty($login) || $this->logins->delete($login)) {
            if ($this->users->delete($user)) {
                $this->Flash->success(__('The user has been deleted.'));
                $dataSource->commit();
                return $this->redirect(['action' => 'index']);
            }
        }
        $dataSource->rollback();
        $this->Flash->error(__('The user could not be deleted. Please, try again.'));

        return $this->redirect(['action' => 'index']);
    }

    /**
     * Sample with session
     */
    public function samplesession()
    {
        $session = $this->getRequest()->getSession();
        if ($this->request->is('post'))
        {
            $keyDelete = $this->request->getData('deletesession');
            if (!empty($keyDelete))
            {
                $session->delete('Auth.User.'.$keyDelete);
            }

            if ($this->request->getData('btnDestroy'))
            {
                $session->destroy();
                return $this->redirect(['action' => 'login']);
            }

            if ($this->request->getData('btnAdd'))
            {
                $key = $this->request->getData('key');
                $value = $this->request->getData('value');
                $session->write('Auth.User.'.$key, $value);
                return $this->redirect(['action' => 'samplesession']);
            }
        }
        $title = 'Danh sách session';
        $this->set(compact('title', 'session'));
    }
    use MailerAwareTrait;

    /**
     * Sample sendemail
     */
    public function sendemail()
    {
        if ($this->request->is('post'))
        {
            if ($this->request->getData('btnSend'))
            {
                $subject = $this->request->getData('subject');
                $to = $this->request->getData('to');
                $cc = $this->request->getData('cc');
                $mess = $this->request->getData('message');
                $this->getMailer('User')->send('sendMyEmail', [$subject, $to, $cc, $mess]);
                return $this->redirect(['action' => 'sendemail']);
            }
        }
        $title = 'Gửi email';
        $this->set(compact('title'));
    }
}
